/*
 * File						: yahei32.c
 * Description		: This file is iHMI43 yahei32.
 * Author					: XiaomaGee@Gmail.com
 * Copyright			:
 *
 * History
 *----------------
 * Rev						: 0.00
 * Date						: 08/25/2012
 *
 * create. 
 *----------------
 */
//---------------- Include files ------------------------//

#include <string.h>
#include "..\include\config.h"
#include "..\include\font.h"
#include "..\fatfs\ff.h"

//---------------- Function Prototype -------------------//
static int get(FONT_MATRIX_T *f);
//---------------- Variable -----------------------------//

DOUBLE_BYTE_FONT_T yahei32 = {
	.name = "Yahei 32 ",
	.id = FONT_UNREGISTERED,
	.height = 32,
	.width = 32,
	.dat = NULL,
	.get_matrix = get,
	.pre = NULL,
	.next = NULL
};

//-----------------Function------------------------------//
/*
 * Name							: get
 * Description			: ---
 * Author						: XiaomaGee.
 *
 * History
 * -----------------
 * Rev							: 0.00
 * Date							: 08/27/2012
 * 
 * create.
 * -----------------
 */
static int
get(FONT_MATRIX_T *f)
{
	FIL fila;
	unsigned long int offset;
	unsigned int counter;
  	
	f_open(&fila,"0:/system/yahei32",FA_READ);
 	
	offset = f->character[0];
	offset -= 0xa1;

	offset *= 94;
	offset += f->character[1];
	offset -= 0xa1;
	offset *= 128;

	f->direction = DIRECTION_H;
	f->height = yahei32.height;
	f->width = yahei32.width;
	
	f_lseek(&fila,offset);


	f_read(&fila,font_buffer,128,&counter);

	f->dat = font_buffer;

	return 0;
}



