/*
 * File								: spi1.c
 * Description				: This file is iHMI43 spi1 driver demo.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */
//-----------------Include files-------------------------//
#include "..\include\hardware.h"
#include "..\include\spi1.h"

#include <stdio.h>

//---------------- Function Prototype ------------------//
static int initialize_spi1(void);
static int write(int number, unsigned char * buf);
static unsigned char send_data(unsigned char data);

//-----------------Variable-----------------------------//  
SYS_SPI_T spi1 = {
	.initialize = initialize_spi1,
	.write = write,
	.send_data = send_data
};

//-----------------Function-----------------------------//
/*
 * Name										: initialize_spi1
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 * 
 * create.
 * ----------------------
 */
static int initialize_spi1(void)
{
	RCC->APB2ENR.B.SPI1EN = 1;
	
	GPIOA->CRL.B.MODE4 = 0x3;       //NSS 50M
	GPIOA->CRL.B.CNF4 = 0x0;        //10ùģʽ
	GPIOA->CRL.B.MODE5 = 0x3;       //CSK 50M
	GPIOA->CRL.B.CNF5 = 0x2;        //10ùģʽ
	GPIOA->CRL.B.MODE7 = 0x3;       //MOSI 50M
	GPIOA->CRL.B.CNF7 = 0x2;        //10ùģʽ

	GPIOA->CRL.B.MODE6 = 0x0;       //MISO
	GPIOA->CRL.B.CNF6 = 0x1;        //01ģʽ(λ״̬)
	//10/ģʽ

	SPI1->CR1.B.BR = 0;             //000 fPCLK/2
	//001 fPCLK/4
	//010 fPCLK/8
	//011 fPCLK/16
	//100 fPCLK/32
	//101 fPCLK/64
	//110 fPCLK/128	36M/128
	//111 fPCLK/256
	SPI1->CR1.B.BIDIMODE = 0;       //0ѡ˫˫ģʽ
	SPI1->CR1.B.CPOL = 0;
	SPI1->CR1.B.CPHA = 0;
	SPI1->CR1.B.DFF = 0;            //1ʹ16λ֡ʽз/գ
																	//0ʹ8λ֡ʽз/գ
	SPI1->CR1.B.LSBFIRST = 0;       //0ȷMSB
	SPI1->CR2.B.SSOE = 1;           //1豸ʱģʽSS
	SPI1->CR1.B.MSTR = 1;           //1Ϊ豸

	SPI1->CR1.B.SSM = 1;
	SPI1->CR1.B.SSI = 1;   

	SPI1->CR1.B.SPE = 1;            //1SPI豸

	SPI1_CS_ON;

	return 0;
}
/*
 * Name										: send_data
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 * 
 * create.
 * ----------------------
 */
static unsigned char send_data(unsigned char data)
{
	while (!(SPI1->SR.B.TXE == 1)) ;

	SPI1->DR = data;

	while (!(SPI1->SR.B.RXNE == 1)) ;

	return SPI1->DR;
}
/*
 * Name										: write
 * Description						: ---
 * Author									: XiaomaGee.
 *
 * History
 * -----------------------
 * Rev										: 0.00
 * Date										: 03/05/2012
 * 
 * create.
 * ----------------------
 */
static int write(int number, unsigned char * buf)
{
	int i;

	SPI1_CS_OFF;

	for (i = 0; i < number; i++) buf[i] = send_data(buf[i]);

	SPI1_CS_ON;

	return 0;
}  
