/*
 * File								: main.c
 * Description				: This file is iHMI43 main driver.
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
//-----------------Include files-------------------------//
#include "..\include\nvic.h"
#include "..\include\rcc.h"
#include "..\include\usart.h"
#include "..\include\hardware.h"
#include "..\include\pwm.h"
#include "..\include\fsmc.h"
#include "..\include\flash.h"
#include "..\include\spi1.h"
#include "..\include\evtft.h"
#include "..\include\font.h"
#include "..\include\bmp.h"
#include "..\include\systick.h"
#include "..\fatfs\ff.h"
#include "..\include\usb_mass.h"

#include <string.h>
#include <stdlib.h>
#include <stdio.h>

//-----------------Function Prototype--------------------//
static int	virtual_u(void);
static int  capture_pic(void);
static int  show_pic(void);

//-----------------Function------------------------------//
/*
 * File								: main
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
int main()
{
	int i = 0;
	FATFS	fatfs;

	for(i=0;i<10000;i++);	
	
	rcc.initialize();
	nvic.initialize();
	fsmc.initialize();
	spi1.initialize();
 
	lcd.initialize();
	pwm.open(100);
	
	virtual_u();
	
	f_mount(0,&fatfs);

	font._default.single_byte=&fixedsys;
	
	show_pic();

	while(1){
	capture_pic();
	}
}
  
/*
 * File								: virtual_u
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
static int
virtual_u(void)
{
	STRING_T s;
	BOX_T b;
	
	KEY_A_INPUT;	
	if(	KEY_A)return 0;
		
	usb_mass.initialize();
	font._default.single_byte = &fixedsys;
		
	//߿
 	b.startx=5;
	b.starty=5;
	b.endx=475;
	b.endy=266;
	b.attrib=BOX_RECESSED;
	b.color=COLOR_BLACK;
	gui.box(&b);
	
	//MESSAGE
	s.x = 10;
	s.y = 10;
	s.space.line=2;
	s.space.word=0;
	s.color=COLOR_LIME;
	s.background_color=COLOR_BLACK;	
	s.inverse=NULL;
	font.printf(&s,"virtual u ........");
	
	while(1);
}

/*
 * File								: captture_pic
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
static int
capture_pic(void)
{
	STRING_T s;

	if(KEY_B == 0 ){
	
	bmp.capture();

	lcd.cls(COLOR_BLACK);

	font._default.single_byte = &fixedsys;
	//MESSAGE
	s.x = 80;
	s.y = 100;
	s.space.line = 2;
	s.space.word = 0;
	s.color = COLOR_SYSTEM;
	s.background_color = COLOR_BLACK;
	s.inverse = NULL;
	font.printf(&s, "capture success!!!");

	usb_mass.initialize();

	while (1) ;
	}

	return 0;
}

/*
 * File								: show_pic
 * Description				: ---
 * Author							: XiaomaGee@Gmail.com
 * Copyright					:
 *
 * History
 *--------------------
 * Rev								: 0.00
 * Date								: 05/9/2012
 *
 * create.
 *--------------------
 */	   
static int
show_pic(void)
{
	STRING_T s;	
	const unsigned char *text[]={
		"this is bmp  -- 1 bit",
		"this is bmp  --  4 bit",
		"this is bmp  --  8 bit",
		"this is bmp  --  16bit_555_x1",
		"this is bmp  --  16bit_555_a1",
		"this is bmp  --  16bit_565",
		"this is bmp  --  24 bit"
		};
	
	const char * name[] = {
		"1bit", "4bit", "8bit","555_x1", 
		"555_a1", "565","24bit"
	};
	int i,j;
	char buffer[50];

	for (i = 0; i < 7; i++) {	
			lcd.cls(COLOR_WINDOW_BACKGROUND);
			s.x = 100;
			s.y = 100;
			s.space.line = 0;
			s.space.word = 0;
			s.color = COLOR_RED;
			s.background_color = COLOR_WINDOW_BACKGROUND;	
			s.inverse = NULL;
			font.printf(&s,"%s",text[i]);
			
			for(j=0;j<5000000;j++);				
			sprintf(buffer, "0:/bmp/%s.bmp", name[i]);
			bmp.show(buffer, 0, 0);
			for(j=0;j<5000000;j++);				
			}
		
	return 0;
}
 